/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Eesh.xs. Do not edit this file, edit Eesh.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Eesh.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "time.h"
#include "Xlib.h"

static Display            *disp;
static Window              comms_win;
static Window              my_win;
static Window              client_win;
static Window              root_win;

/*
 * A bunch of routines copied and hacked from the eesh source code
 */

void SetupX() {
   char *display_name = NULL;
   disp = XOpenDisplay(display_name);
   /* if cannot connect to display */
   if (!disp)
     {
	fprintf(stderr,
	   "Eesh cannot connect to the display nominated by\n"
	   "your shell's DISPLAY environment variable.\n"
	);
	exit(1);
     }

   root_win = DefaultRootWindow(disp);

   /* warn, if necessary about X version problems */
   if (ProtocolVersion(disp) != 11)
     {
	fprintf(
	   stderr,
	   "WARNING:\n"
	   "This is not an X11 Xserver. It infact talks the X%i protocol.\n",
	   ProtocolVersion(disp)
	);
     }
}


void
CommsSend( char *command )
{
   char                ss[21];
   int                 i, j, k, len;
   XEvent              ev;
   Atom                a;

   if ( !command ) croak( "No command passed to C routine CommsSend" ) ;

   len = strlen(command);
   a = XInternAtom(disp, "ENL_MSG", True);
   ev.xclient.type = ClientMessage;
   ev.xclient.serial = 0;
   ev.xclient.send_event = True;
   ev.xclient.window = comms_win ;
   ev.xclient.message_type = a;
   ev.xclient.format = 8;

   for (i = 0; i < len + 1; i += 12)
     {
	sprintf(ss, "%8x", (int)my_win);
	for (j = 0; j < 12; j++)
	  {
	     ss[8 + j] = command[i + j];
	     if (!command[i + j])
		j = 12;
	  }
	ss[20] = 0;
	for (k = 0; k < 20; k++)
	   ev.xclient.data.b[k] = ss[k];
	XSendEvent(disp, comms_win, False, 0, (XEvent *) & ev);
     }
}

void
CommsFindCommsWindow()
{
   unsigned char      *s;
   Atom                a, ar;
   unsigned long       num, after;
   int                 format;
   Window              rt;
   int                 dint;
   unsigned int        duint;

   a = XInternAtom(disp, "ENLIGHTENMENT_COMMS", True);
   if (a != None)
     {
	s = NULL;
	XGetWindowProperty(disp, root_win, a, 0, 14, False, AnyPropertyType, &ar,
			   &format, &num, &after, &s);
	if (s)
	  {
	     sscanf((char *)s, "%*s %x", (unsigned int *)&comms_win);
	     XFree(s);
	  }
	else
	   (comms_win = 0);
	if (comms_win)
	  {
	     if (!XGetGeometry(disp, comms_win, &rt, &dint, &dint,
			       &duint, &duint, &duint, &duint))
		comms_win = 0;
	     s = NULL;
	     if (comms_win)
	       {
		  XGetWindowProperty(disp, comms_win, a, 0, 14, False,
				  AnyPropertyType, &ar, &format, &num, &after,
				     &s);
		  if (s)
		     XFree(s);
		  else
		     comms_win = 0;
	       }
	  }
     }
}


#line 136 "Eesh.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 280 "Eesh.c"

XS_EUPXS(XS_Eesh_e_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Eesh_e_open)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 131 "Eesh.xs"
      /* Inspired by eesh's main.c.  Yeah, that's it: 'inspired'. */

      SetupX() ;
      my_win = XCreateSimpleWindow(disp, root_win, -100, -100, 5, 5, 0, 0, 0);
      CommsFindCommsWindow();
      XSelectInput(disp, comms_win, StructureNotifyMask);
      XSelectInput(disp, root_win, PropertyChangeMask);
      CommsSend( "set clientname Eesh.pm");
      CommsSend( "set version 0.1");
      CommsSend( "set author The Rasterman interpreted by Barrie Slaymaker");
      CommsSend( "set email barries@slaysys.com");
      CommsSend( "set web http://www.slaysys.com/");
   /*  CommsSend( "set address NONE"); */
      CommsSend( "set info Eesh.pm: Enlightenment IPC - talk to E from Perl");
   /*  CommsSend( "set pixmap 0"); */

      XSync(disp, False) ;
#line 307 "Eesh.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Eesh_e_send); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Eesh_e_send)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "command");
    {
	char *	command = (char *)SvPV_nolen(ST(0))
;
#line 154 "Eesh.xs"
      CommsSend(command);
      XSync(disp,False);
#line 325 "Eesh.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Eesh_e_fileno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Eesh_e_fileno)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 161 "Eesh.xs"
      RETVAL = ConnectionNumber(disp) ;
#line 342 "Eesh.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Eesh_e_recv_nb); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Eesh_e_recv_nb)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "blocking");
    {
	int	blocking = (int)SvIV(ST(0))
;
#line 168 "Eesh.xs"
      fd_set          in_fds ;
      struct timeval  tv, *tvp ;
      int             c ;
      XEvent          ev ;
      int             chunk_len ;
      char           *msg ;
      int             msg_len ;
      int             max_msg_len ;
#line 366 "Eesh.c"
	SV *	RETVAL;
#line 177 "Eesh.xs"
      msg = 0 ;
      do {
         if ( blocking )
	    tvp = NULL ;
	 else {
	    tvp = &tv ;
	    tv.tv_sec = 0 ;
	    tv.tv_usec = 0 ;
	 }
	 FD_ZERO( &in_fds );
	 FD_SET( ConnectionNumber(disp), &in_fds );
	 c = select( ConnectionNumber(disp)+1, &in_fds, NULL, NULL, tvp ) ;
	 if ( c < 0 )
	    croak( "select() returned < 0" ) ;
	 if ( !c && !blocking ) {
	    XSRETURN_UNDEF ;
	 }

	 chunk_len = 0 ;
	 while (XPending(disp)) {
	    XNextEvent(disp,&ev) ;
	    if (ev.type == ClientMessage) {
	       if ( !msg ) {
		  max_msg_len = 1000 ;
		  msg = malloc( max_msg_len + 1 );
		  if ( !msg ) {
		     XSRETURN_UNDEF;
		  }
		  for (
		     chunk_len = 0, msg_len = 0 ;
		     chunk_len < 12;
		     ++chunk_len, ++msg_len
		  ) {
		     msg[msg_len] = ev.xclient.data.b[ chunk_len + 8 ];
		     if ( ! msg[msg_len] ) break ;
		  }
	       }
	       else {
		  for (
		     chunk_len = 0 ;
		     chunk_len < 12 ;
		     ++chunk_len, ++msg_len
		  ) {
		     if ( msg_len > max_msg_len ) {
		        max_msg_len += 1000 ;
			msg = realloc( msg, max_msg_len + 1 );
			if ( !msg ) {
			   XSRETURN_UNDEF;
			}
		     }
		     msg[msg_len] = ev.xclient.data.b[ chunk_len + 8 ];
		     if ( ! msg[msg_len] ) break ;
		  }
	       }
	    }
	 }
      } while ( chunk_len >= 12 ) ;
      ST(0) = sv_newmortal() ;
      if ( msg ) {
	 msg[msg_len] = '\0' ;
	 sv_setpv( ST(0), msg ) ;
      }
      else
	 ST(0) = &PL_sv_undef ;
#line 433 "Eesh.c"
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Eesh); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Eesh)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Eesh::e_open", XS_Eesh_e_open);
        newXS_deffile("Eesh::e_send", XS_Eesh_e_send);
        newXS_deffile("Eesh::e_fileno", XS_Eesh_e_fileno);
        newXS_deffile("Eesh::e_recv_nb", XS_Eesh_e_recv_nb);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
